/**
        * Ce programme sert  montrer l'utilisation
        * des Listes et sous-listes en Java

        * @author Guy Lapalme
        * @author Mohamed Lokbani (que qcqs commentaires)

        * @version 1.1
*/


import java.util.*;

class TestSousListes {
    public static void main(String args[]) {  

	/**
	   On dfinit une liste du type ArrayList
	*/

        List l = new ArrayList();

	/**
	   On insre quelques lments
	*/

        for (int i=0; i<10; i++)
            l.add(new Integer(i));

	/**
	   On extrait une sous liste
	   index de dpart (inclus): 2
	   index d'arrive (nom inclus): 6
	*/

        List sl = l.subList(2,6);

	/**
	   Quelques traitements sur la liste et la sous
	   liste
	   Attention:

	   les modifications sur la sous liste affectent le
	   contenu de la liste.
	   il est de mme pour la sous liste, quoi que  ce niveau
	   l'accs  la sous-liste va provoquer une erreur.
	*/
        
        out("original",l,sl);
        sl.add(2,new Integer(30));
        out("sl.add(2,30)",l,sl);
        sl.remove(4);
        out("sl.remove(4)",l,sl);
        Collections.sort(sl);
        out("sort(sl)",l,sl);
        l.add(3,new Integer(50));
        out("l.add(3,50)",l,sl);        
    }


    /**
      Une fonction pour afficher un message et le contenu
      des listes.
      @param mess le message en question
      @param l une liste donne
      @param sl une sous liste de l
    */
      
    public static void out(String mess,List l,List sl){
        System.out.println(mess);
        System.out.println("l="+l);
        System.out.println("sl="+sl);
    }
}

/* exemple de rsultat

original
l=[0, 1, 2, 3, 4, 5, 6, 7, 8, 9]
sl=[2, 3, 4, 5]
sl.add(2,30)
l=[0, 1, 2, 3, 30, 4, 5, 6, 7, 8, 9]
sl=[2, 3, 30, 4, 5]
sl.remove(4)
l=[0, 1, 2, 3, 30, 4, 6, 7, 8, 9]
sl=[2, 3, 30, 4]
sort(sl)
l=[0, 1, 2, 3, 4, 30, 6, 7, 8, 9]
sl=[2, 3, 4, 30]
l.add(3,50)
l=[0, 1, 2, 50, 3, 4, 30, 6, 7, 8, 9]
Exception in thread "main" java.util.ConcurrentModificationException
        at java.util.SubList.checkForComodification(AbstractList.java:845)
        at java.util.SubList.listIterator(AbstractList.java:775)
        at java.util.AbstractList.listIterator(AbstractList.java:345)
        at java.util.SubList.iterator(AbstractList.java:771)
        at java.util.AbstractCollection.toString(AbstractCollection.java:443)
        at java.lang.String.valueOf(String.java:1947)
        at java.lang.StringBuffer.append(StringBuffer.java:370)
        at TestSousListes.out(TestSousListes.java:72)
        at TestSousListes.main(TestSousListes.java:57)
*/
